<i18n>
{
  "fr": {
    "title-1": "Suppression",
    "delete-msg": "Êtes vous sûr de vouloir supprimer l'achat",
    "label-1": "Validité",
    "label-2": "Valide",
    "label-3": "Non valide",
    "label-4": "Code NACRES",
    "label-5": "Intitulé NACRES",
    "label-6": "Montant en euros",
    "label-7": "Non utilisé",
    "label-8": "Module",
    "label-9": "Aucun",
    "field-1": "Aucun achat"
  },
  "en": {
    "title-1": "Delete",
    "delete-msg": "Are you sure you want to delete the purchase",
    "label-1": "Validity",
    "label-2": "Valid",
    "label-3": "Invalid",
    "label-4": "NACRES code",
    "label-5": "NACRES description",
    "label-6": "Amount in euros",
    "label-7": "Not used",
    "label-8": "Module",
    "label-9": "None",
    "field-1": "No purchase"
  }
}
</i18n>

<template>
    <b-table
      :data="purchases"
      :striped="true"
      :narrowed="true"
      :hoverable="true"
      :sort-icon="'angle-up'"
      default-sort-direction="desc"
      paginated
      per-page="20"
      default-sort="score"
    >
      <b-table-column
        :label="$t('label-1')"
        field="score"
        sortable
        centered
        v-slot="props"
      >
        <b-tag rounded v-if="props.row.score!==2" type="is-success">{{ $t('label-2') }}</b-tag>
        <b-tag rounded v-else type="is-danger">{{ $t('label-3') }}</b-tag>
      </b-table-column>
      <b-table-column
        :label="$t('label-8')"
        field="module"
        sortable
        centered
        v-slot="props"
      >
        <b-tag rounded type="is-success" v-if="props.row.module==purchasesModule">{{ $t(props.row.module) }}</b-tag>
        <b-tag rounded v-else-if="props.row.module">{{ $t(props.row.module) }}</b-tag>
        <b-tag rounded type="is-danger" v-else> {{ $t('label-9') }} </b-tag>
      </b-table-column>
      <b-table-column
        :label="$t('label-4')"
        field="code"
        sortable
        v-slot="props"
      >
        {{ props.row.code.toUpperCase() }}
      </b-table-column>
      <b-table-column
        :label="$t('label-5')"
        v-slot="props"
      >
        {{ props.row.getFactorDescription() }}
      </b-table-column>
      <b-table-column
        :label="$t('label-6')"
        field="amount"
        sortable
        numeric
        v-slot="props"
      >
        {{ props.row.amount | splitFloat }} €
      </b-table-column>
      <b-table-column width="120" v-slot="props">
        <div class="panel-block">
          <b-tooltip
            :label="$t('edit')"
            type="is-black"
          >
            <b-button
              :disabled="submitted"
              size="is-small"
              icon-left="pencil"
              @click="edit(props.row)"
            />
          </b-tooltip>
          <b-tooltip
            :label="$t('delete')"
            type="is-black"
          >
            <b-button
              size="is-small"
              :disabled="submitted"
              icon-left="trash"
              @click="del(props.row)"
            />
          </b-tooltip>
        </div>
      </b-table-column>
      <section slot="empty" class="section">
        <div class="content has-text-grey has-text-centered">
          <p>
            <i class="sui sui-ban" style="font-size: 64px;"></i>
          </p>
          <p>{{ $t('field-1') }}</p>
        </div>
      </section>
    </b-table>
</template>

<script>
import Purchase from '@/models/carbon/Purchase.js'

export default {
  name: 'PurchasesTable',
  computed: {
    purchases: function () {
      return this.$store.getters['purchases/items']
    },
    purchasesModule: function () {
      return Purchase.MODULE_NAME
    },
    submitted: function () {
      return this.$store.getters['ghgi/item']['purchasesSubmitted']
    }
  },
  methods: {
    edit: function (purchase) {
      this.$emit('edit', purchase)
    },
    del: function (purchase) {
      let self = this
      this.$buefy.dialog.confirm({
        title: self.$t('title-1'),
        message: self.$t('delete-msg') + ' <strong>' + purchase.code.toUpperCase() + '</strong>?',
        confirmText: self.$t('validate'),
        cancelText: self.$t('cancel'),
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          self.$store.dispatch('purchases/delete', purchase)
          self.$store.commit('purchases/ISMODIFIED', true)
          self.$emit('del')
        }
      })
    }
  }
}
</script>

<style>
.table td {
  vertical-align: middle !important;
}
</style>
